package com.loafle.overflow.model.meta;

import javax.persistence.*;
import java.util.Date;

@Entity
@Table(name = "META_IP_TYPE", schema = "public")
public class MetaIPType {

  private Short id;
  private String name;
  private String key;
  private Date createDate;

  public MetaIPType() {
  }

  public MetaIPType(Short id) {
    this.id = id;
  }

  @Id
  public Short getId() {
    return id;
  }

  public void setId(Short id) {
    this.id = id;
  }

  @Column(name = "KEY", nullable = true, length = 50)
  public String getKey() {
    return key;
  }

  public void setKey(String key) {
    this.key = key;
  }

  @Column(name = "NAME", nullable = true, length = 50)
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  @Temporal(TemporalType.TIMESTAMP)
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  public static enum Enum {
    V4((short) 1), V6((short) 2),;

    private final Short value;

    /**
     * @param value
     */
    Enum(final Short value) {
      this.value = value;
    }

    public Short getValue() {
      return this.value;
    }

    public MetaIPType to() {
      return new MetaIPType(this.value);
    }
  }
}
